﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Infragistics4.Web.v14.1, Version=14.1.20141.2150, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" Namespace="Infragistics.Web.UI.GridControls" TagPrefix="ig" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
    <head runat="server">
        <title></title>
        <script type="text/javascript" id="igClientScript">
            function WebDataGrid1_CellEditing_EnteredEditMode(sender, eventArgs) {
                if (eventArgs.getCell().get_column().get_key() != 'SupplierID') {
                    return;
                }

                var categoryId = eventArgs.getCell().get_row().get_cellByColumnKey('CategoryID').get_value();
	
                var defaultSelected = null;

                // set desired value based on the other dropdown
                if (categoryId == 1) {
                    defaultSelected = 1;
                } else {
                    defaultSelected = 5;
                }

                if (defaultSelected) {
                    var editor = eventArgs.getEditor();
                    editor.selectItem(editor.get_items().get_item(defaultSelected), true, true);
                }
            }
        </script>
    </head>
    <body>
        <form id="form" runat="server">
            <asp:ScriptManager runat="server" />
            <ig:WebDataGrid ID="WebDataGrid1" runat="server" DataKeyFields="ProductID"
                            AutoGenerateColumns="False"
                            ViewStateMode="Disabled" Width="98%" 
                            Height="500px" DataSourceID="ProductsSqlDataSource">
                <Columns>
                    <ig:BoundDataField DataFieldName="ProductID" Key="ProductID" >
                        <Header Text="ProductID" />
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="ProductName" Key="ProductName">
                        <Header Text="ProductName" />
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="SupplierID" Key="SupplierID">
                        <Header Text="SupplierID" />
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="CategoryID" Key="CategoryID">
                        <Header Text="CategoryID" />
                    </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="QuantityPerUnit" Key="QuantityPerUnit">
                        <Header Text="QuantityPerUnit" />
                    </ig:BoundDataField>
                </Columns>
                <EditorProviders>
                    <ig:DropDownProvider ID="CategoriesDropDownProvider">
                        <EditorControl DisplayMode="DropDown" DataSourceID="CategoriesSqlDataSource" 
                                       ValueField="CategoryID" TextField="CategoryName"                                         
                                       AutoPostBackFlags-SelectionChanged="Off">
                            <DropDownItemBinding TextField="CategoryName" ValueField="CategoryID"></DropDownItemBinding>
                        </EditorControl>
                    </ig:DropDownProvider>
                    <ig:DropDownProvider ID="SuppliersDropDownProvider">
                        <EditorControl DisplayMode="DropDown" DataSourceID="SuppliersSqlDataSource" 
                                       AutoPostBackFlags-SelectionChanged="Off"
                                       ValueField="SupplierID" TextField="CompanyName" 
                                       Width="100%">
                            <DropDownItemBinding TextField="CompanyName" ValueField="SupplierID"></DropDownItemBinding>
                        </EditorControl>
                    </ig:DropDownProvider>
                </EditorProviders>
                <Behaviors>
                    <ig:EditingCore AutoCRUD="true">
                        <Behaviors>
                            <ig:CellEditing Enabled="true">
                                <CellEditingClientEvents EnteredEditMode="WebDataGrid1_CellEditing_EnteredEditMode" />
                                <EditModeActions EnableF2="true" EnableOnActive="true" MouseClick="Single" />
                                <ColumnSettings>
                                    <ig:EditingColumnSetting ColumnKey="CategoryID" EditorID="CategoriesDropDownProvider" />
                                    <ig:EditingColumnSetting ColumnKey="SupplierID" EditorID="SuppliersDropDownProvider" />
                                </ColumnSettings>
                            </ig:CellEditing>
                            <ig:RowAdding Alignment="Bottom" 
                                          EditModeActions-EnableOnActive="true" 
                                          EditModeActions-MouseClick="Single"
                                          Enabled="true">
                                <AddNewRowClientEvents EnteredEditMode="WebDataGrid1_CellEditing_EnteredEditMode" />
                                <ColumnSettings>
                                    <ig:RowAddingColumnSetting ColumnKey="CategoryID" EditorID="CategoriesDropDownProvider" />
                                    <ig:RowAddingColumnSetting ColumnKey="SupplierID" EditorID="SuppliersDropDownProvider" />
                                </ColumnSettings>
                                <EditModeActions MouseClick="Single" EnableOnActive="True"></EditModeActions>
                            </ig:RowAdding>
                            <ig:RowDeleting Enabled="true" />
                        </Behaviors>
                    </ig:EditingCore>
                    <ig:Activation></ig:Activation>
                </Behaviors>
            </ig:WebDataGrid>
            <asp:SqlDataSource ID="ProductsSqlDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>" ProviderName="<%$ ConnectionStrings:ConnectionString.ProviderName %>" SelectCommand="SELECT [ProductID], [ProductName], [CategoryID], [SupplierID], [QuantityPerUnit] FROM [Products]" DeleteCommand="DELETE FROM [Products] WHERE [ProductID] = ?" InsertCommand="INSERT INTO [Products] ([ProductID], [ProductName], [CategoryID], [SupplierID], [QuantityPerUnit]) VALUES (?, ?, ?, ?, ?)" UpdateCommand="UPDATE [Products] SET [ProductName] = ?, [CategoryID] = ?, [SupplierID] = ?, [QuantityPerUnit] = ? WHERE [ProductID] = ?">
                <DeleteParameters>
                    <asp:Parameter Name="ProductID" Type="Int32" />
                </DeleteParameters>
                <InsertParameters>
                    <asp:Parameter Name="ProductID" Type="Int32" />
                    <asp:Parameter Name="ProductName" Type="String" />
                    <asp:Parameter Name="CategoryID" Type="Int32" />
                    <asp:Parameter Name="SupplierID" Type="Int32" />
                    <asp:Parameter Name="QuantityPerUnit" Type="String" />
                </InsertParameters>
                <UpdateParameters>
                    <asp:Parameter Name="ProductName" Type="String" />
                    <asp:Parameter Name="CategoryID" Type="Int32" />
                    <asp:Parameter Name="SupplierID" Type="Int32" />
                    <asp:Parameter Name="QuantityPerUnit" Type="String" />
                    <asp:Parameter Name="ProductID" Type="Int32" />
                </UpdateParameters>
            </asp:SqlDataSource>
            <asp:SqlDataSource ID="CategoriesSqlDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>" ProviderName="<%$ ConnectionStrings:ConnectionString.ProviderName %>" SelectCommand="SELECT [CategoryID], [CategoryName] FROM [Categories]"></asp:SqlDataSource>
            <asp:SqlDataSource ID="SuppliersSqlDataSource" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>" ProviderName="<%$ ConnectionStrings:ConnectionString.ProviderName %>" SelectCommand="SELECT [SupplierID], [CompanyName] FROM [Suppliers]"></asp:SqlDataSource>
        </form>
    </body>
</html>